class Measurement {
  int measurementID;
  int timeMeasured;
  Sensor sensor;
  List<Data> dataList;
  List<Corner> cornerList;

  Measurement({
    required this.measurementID,
    required this.timeMeasured,
    required this.sensor,
    required this.dataList,
    required this.cornerList,
  });

  factory Measurement.Measurement(Map<String, dynamic> json) {
    return Measurement(
      measurementID: json['MeasurementID'],
      timeMeasured: json['TimeMeasured'],
      sensor: Sensor.fromJson(json['Sensor']),
      dataList: (json['Data'] as List<dynamic>)
          .map((data) => Data.fromJson(data))
          .toList(),
      cornerList: (json['Corner'] as List<dynamic>)
          .map((data) => Corner.fromJson(data))
          .toList(),
    );
  }
}

class Sensor {
  int sensorID;
  String sensorType;
  bool active;

  Sensor({
    required this.sensorID,
    required this.sensorType,
    required this.active,
  });

  factory Sensor.fromJson(Map<String, dynamic> json) {
    return Sensor(
      sensorID: json['SensorID'],
      sensorType: json['SensorType'],
      active: json['Active'],
    );
  }
}

class Data {
  double latitude;
  double longitude;
  double iceTop;
  double iceBottom;
  double calculatedThickness;
  double accuracy;

  Data({
    required this.latitude,
    required this.longitude,
    required this.iceTop,
    required this.iceBottom,
    required this.calculatedThickness,
    required this.accuracy,
  });

  factory Data.fromJson(Map<String, dynamic> json) {
    return Data(
      latitude: json['Latitude'],
      longitude: json['Longitude'],
      iceTop: json['IceTop'],
      iceBottom: json['IceBottom'],
      calculatedThickness: json['CalculatedThickness'],
      accuracy: json['Accuracy'],
    );
  }
}

class Corner {
  double cornerID;
  double latitude;
  double longitude;

  Corner({
    required this.cornerID,
    required this.latitude,
    required this.longitude,
  });

  factory Corner.fromJson(Map<String, dynamic> json) {
    return Corner(
      cornerID: json['CornerID'],
      latitude: json['CornerLatitude'],
      longitude: json['CornerLongitude'],
    );
  }
}